#!/usr/bin/python

# Check whether a certain IP address is part of a list of CIDR networks
# 2012 Matthaeus Wander <matthaeus.wander@uni-due.de>

import ipaddr

class networklist(object):
    def __init__(self, netlist):
        self.networks = []
        self.cache = {}
        for net in netlist:
            self.networks.append(ipaddr.IPNetwork(net))
    def __iter__(self):
        return self.networks.__iter__()
    def __contains__(self, ip):
        if ip in self.cache:
            return self.cache[ip]

        # Build cache
        ipa = ipaddr.IPAddress(ip)
        for net in self.networks:
            if ipa in net:
                self.cache[ip] = True
                return True

        self.cache[ip] = False
        return False
